// telecSM.c
// versione state machine
// richiede la libreria  "LCD_44780.c"

// -- INCLUDE --
/* "telec.h" :specifiche del telecomando
	definisce le costanti: 
	SIGLATELEC	// sigla del telecomando
	NTASTI 		//n. tasti da rilevare
	STATOAT 	// stato attivo 0=mark, 1=space
	ONE_TK 		// durata dello stato attivo dell'ONE in ticks di 50us	
	ZERO_TK
	IMPTOUT_TK 	// timeout= durata massima impulso= durata minima gap (10ms)
	TOL_TK 		// margine di tolleranza in + e -
	SCB 		// StartCommandBit:dove comincia il command nella squenza impulsi (lo Start  0) 
	NCB 		//n. di bit del command
	e gli array:
	unsigned char Commands[]	//array dei Commands per i tasti
	unsigned char TastiNN[]		//array dei codici ascii dei tasti non numerici
*/
#include "telecSM.h"

// -- PROTOTIPI FUNZIONI locali alla libreria --
void ScriviSeq(unsigned char durate[],unsigned char ndurate);
unsigned char DecodSeq(unsigned char durate[],unsigned char Commands[]);
unsigned char Confronta(unsigned char cosa,unsigned char concosa,unsigned char Tol);


void ScriviSeq(unsigned char durate[],unsigned char ndurate){
	unsigned char i;
	printf(" \r\n ");	// a capo
	for(i=0;i<ndurate;i++){
		printf("%u  ",durate[i]);
	}
}
unsigned char DecodSeq(unsigned char durate[],unsigned char Commands[]){
	// durate[0] contiene lo Start; durate[1] la durata del LSB, durate[NCB] MSB
	// per ogni durate[i] confronta il valore con ONE_TK,ZERO_TK,TOL_TK per vedere se rappresenta 0 o 1
	// se no  n 0 n 1 ritorna 255
	// converte quindi durate[] binario->dec   questo  il Command
	// cerca sequenzialmente Command nell'array Commands[]
	// se lo trova restituisce l'ascii del tasto, altrimenti ritorna 255
	unsigned char Tasto=255,Command=0,i,pot2=1,ibit;
	// ciclo nell'array durate[], da 1 a NCB
	for(i=1;i<=NCB;i++){
		if( Confronta(durate[i],ZERO_TK,TOL_TK) )
			ibit=0;
		else
			if( Confronta(durate[i],ONE_TK,TOL_TK)) ibit=1; else return Tasto;
		Command+=ibit*pot2;
		pot2*=2;
	}	
	// cerca Command in Commands[]
	for(i=0;i<NTASTI;i++)
		if(Commands[i]==Command) break;
	// i primi 10 tasti sono i numeri da 0 a 9; per i successivi il carattere va cercato nell'array TastNN[];
	if(i<10) Tasto=i+48;		// codice ascii del numero
	else if(i<NTASTI) Tasto=TastiNN[i-10];
	return Tasto;
}


unsigned char Confronta(unsigned char cosa,unsigned char concosa,unsigned char Tol){
	if(  (cosa>=(concosa-Tol)) && (cosa<=(concosa+Tol)) ) return 1;
	else return 0;
}
